import {GameModel} from "../GameModel";
import {ItemGroup} from "../inventory/ItemGroup";
import {AbstractItemGroup} from "../inventory/AbstractItemGroup";

export class ItemgroupUtilities {

  public static findItemgroupPathToItemgroup(searchedItemgroupName: string, itemgroups: ItemGroup[]): ItemGroup[] {
    for(let i=0; i<itemgroups.length; i++) {
      const found_path = this.findItemgroupPathToItemgroupRecursive(itemgroups[i], searchedItemgroupName, []);
      if(found_path.length > 0) {
        return found_path;
      }
    }
    return [];
  }

  private static findItemgroupPathToItemgroupRecursive(root: ItemGroup, searchedItemgroupName: string, path: ItemGroup[]): ItemGroup[] {
    path.push(root);

    if(root.componentName === searchedItemgroupName) {
      return path;
    }

    if(root instanceof AbstractItemGroup) {
      for(let i=0; i<root.children.length; i++) {
        const found_path = this.findItemgroupPathToItemgroupRecursive(root.children[i], searchedItemgroupName, path.concat())
        if(found_path != undefined && found_path.length > 0) {
          return found_path;
        }
      }
      return [];
    } else {
      return [];
    }
  }

}
